SystemOrganization addCategory: #'Seaside-Tests-Playground'!

WAComponent subclass: #WAPlaygroundComponent
	instanceVariableNames: 'code callbackValues simpleTag formTag tableTag jqueryTag currentPosition history saved msValue privateStyle'
	classVariableNames: 'Log'
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 18:43'!
anchorCallbackTemplate
	^'html anchor callback: []; with: ''Click me''.'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/5/2010 20:53'!
anchorClickTemplate
	^'html anchor onClick: (html javascript alert: ''Test''); with: ''Click me''.'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 14:06'!
cancelButtonTemplate
	^'html cancelButton value: ''Cancel''.'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 13:52'!
checkBoxTemplate
	^'html checkbox
   callback: [:value | values at: #checkbox1 put: value];
   value: (values at: #checkbox1 ifAbsent: [false]);
   with: ''Checkbox 1''.'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 13:43'!
containerTableTemplate
	^'html table: [
   html tableRow: [
     html tableData: [].
     html tableData: []].
   html tableRow: [
     html tableData: [].
     html tableData: []].
   ].'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
description
	^ 'Seaside playground'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 13:04'!
exampleCode
^'html big: ''TEST Playground''.
html form: [
 html multiSelect list: #(11 12 13 14 15);
   selected: (values at: #list ifAbsent: []);
   callback: [:v | values at: #list put: v ].
 html break.
 html textInput value: (values at: #input ifAbsent: []);  callback: [:v | values at: #input put: v].
 html break.
html submitButton value: ''OK'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/2/2010 20:39'!
exampleJQCode
^'html anchor
 onClick: ((html jQuery: #itsme) fadeIn: 1 seconds);
 with: ''Show''.
html space: 2.
html anchor
 onClick: ((html jQuery: #itsme) hide: 1 seconds);
 with: ''Hide''.
html div id: ''itsme'';
 style: ''border:1px solid #ccc;width:100px;background:#fee'';
 with: [
  html div: ''I am DIV''.
  html div: ''with some text....'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/5/2010 19:08'!
formTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #list put: self listTemplate.
	dict at: #listOptional put: self listOptionalTemplate.
	dict at: #multiList put: self multiListTemplate.
	dict at: #form put: self formTemplate.
	dict at: #inputField put: self textInputTemplate.
	dict at: #radioButton put: self radioButtonTemplate.
	dict at: #checkBox put: self checkBoxTemplate.
	dict at: #textField put: self textAreaTemplate.
	dict at: #submitButton put: self submitButtonTemplate.
	dict at: #cancelButton put: self cancelButtonTemplate.
	dict at: #resetButton put: self resetButtonTemplate.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/11/2010 13:19'!
formTemplate
	^'html form: [  ].'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/3/2010 21:06'!
fullTableTemplate
	^'html table: [
   html tableRow: [
     html tableHeading: ''Header 1''.
     html tableHeading: ''Header 2''].
   html tableRow: [
     html tableData: ''Data 1''.
     html tableData: ''Data 2''].
   ].'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
handlerName
	^'examples/playground'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/11/2010 21:01'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: self handlerName.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary.
	Log := false! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/5/2010 19:50'!
jqueryTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #anchorClick put: self anchorClickTemplate.
	dict at: #effectPulsate put: 'html anchor onClick: ((html jQuery: ''.box'') effect pulsate times: 2); with: ''Pulsate''.'.
	dict at: #effectShake put: 'html anchor onClick: ((html jQuery: ''.box'') effect shake; distance: 5; times: 3); with: ''Shake''.'.
	dict at: #effectBounce put: 'html anchor onClick: ((html jQuery: ''.box'') effect bounce; easing: ''linear''; times: 2); with: ''Bounce''.'.
	dict at: #effectHighlight put: 'html anchor onClick: ((html jQuery: ''.box'') effect speed: 2000); with: ''Highlight''.'.
	dict at: #formSubmit put: 'html anchor onClick: (html jQuery ajax serializeForm); with: ''OK''].'.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 13:59'!
listOptionalTemplate
	^'html select list: #(1 2 3 4 5);
   beOptional;
   optionalLabel: ''(none)'';
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/3/2010 21:16'!
listTemplate
	^'html select list: #(1 2 3 4 5);
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:39'!
log: aBoolean
	"Log := true"
	Log := aBoolean! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:39'!
logEnabled
	^Log == true! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/3/2010 21:16'!
multiListTemplate
	^'html multiSelect list: #(11 12 13 14 15);
   size: 4;
   selected: (values at: #multiList1 ifAbsent: []);
   callback: [:v | values at: #multiList1 put: v].'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 13:54'!
radioButtonTemplate
	^'html radioGroup
   callback: [:value | values at: #radio1 put: value];
   selected: (values at: #radio1 ifAbsent: []);
   with: [:group | 
    #(''Radio 1'' ''Radio 2'') do: [:each |
     group radioButton value: each.
     html text: each.
     html break]].'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 14:10'!
resetButtonTemplate
	^'html button beReset; with: ''Reset''.'.! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 13:20'!
simpleTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #break put: 'html break.'.
	dict at: #paragraph put: 'html paragraph.'.
	dict at: #div put: 'html div: [  ].'.
	dict at: #divBox put: 'html div class: ''box''.'.
	dict at: #text put: 'html text: ''a text''.'.
	dict at: #span put: 'html span: [  ].'.
	dict at: #hr put: 'html horizontalRule.'.
	dict at: #heading put: 'html heading level2; with: ''Title''.'.
	dict at: #big put: 'html big: ''BIG''.'.
	dict at: #space put: 'html space.'.
	dict at: #anchorCallback put: self anchorCallbackTemplate.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/4/2010 14:06'!
submitButtonTemplate
	^'html submitButton callback: []; value: ''OK''.'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/11/2010 13:20'!
tableTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #table put: 'html table: [  ].'.
	dict at: #tableData put: 'html tableData: [  ].'.
	dict at: #tableHeading put: 'html tableHeading: [  ].'.
	dict at: #tableRow put: 'html tableRow: [  ].'.
	dict at: #tableWithHeader put: self fullTableTemplate.
	dict at: #tableContainer put: self containerTableTemplate.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/3/2010 21:18'!
textAreaTemplate
	^'html textArea
   rows: 5;
   columns: 60;
   callback: [:value | values at: #text1 put: value];
   value: (values at: #text1 ifAbsent: ['''']).'! !

!WAPlaygroundComponent class methodsFor: 'templates' stamp: 'obi 1/3/2010 21:17'!
textInputTemplate
	^'html textInput
   callback: [:value | values at: #input1 put: value];
   value: (values at: #input1 ifAbsent: ['''']).'! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 21:53'!
addTagScriptOn: script type: aSymbol
	| code1 code2 codePart newPosition index offset |
	codePart := self templateAt: aSymbol.
	codePart isNil ifTrue: [^self].
	script add: (script jQuery id: 'codeDiv') effect.
	index := codePart findString: '[  ]' startingAt: 1 .
	offset := index > 0 ifTrue: [offset := index - codePart size + 1] ifFalse: [0].
	currentPosition < code size
		ifTrue: [	code1 := code copyFrom: 1 to: currentPosition.
				code2 := code copyFrom: currentPosition + 1 to: code size.
				code := code1,'
  ' , codePart , code2.
	newPosition := currentPosition + codePart size + 3. ]
		ifFalse: [
			code isEmpty 
				ifTrue: [code := ' ', codePart]
				ifFalse: [code := code, '
  ',codePart ]. 
			newPosition := code size ].
	newPosition := newPosition + offset.	
	self perform: (aSymbol ,':') asSymbol with: nil.
	script add: ((script jQuery id: 'codeDiv') html: [:r | self renderCodeOn: r]).
	script add: ((script jQuery id: 'lists') html: [:r | self renderListsOn: r]).
	script add: ((script jQuery id: 'output') html: [:r | self renderOutputOrErrorOn: r]).
	script add: ((script jQuery id: 'timeValue') html: [:r | self renderTimeValueOn: r]).

	script add: (JSStream on: 'setCursorPosition(', newPosition asString, ')').
	self addToHistory! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:36'!
addToHistory
	history isEmpty ifFalse: [history last = code ifTrue: [ ^self ] ].
	history add: code! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/10/2010 20:21'!
allowedSelectors
	
	| allowed theClasses |
	allowed := OrderedCollection new.
	theClasses := OrderedCollection with: WARenderCanvas.
	theClasses addAll: WARenderCanvas allSuperclasses.
	theClasses do: [:cl | cl = Object ifTrue: [^allowed] ifFalse: [allowed add: cl selectors]]! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 13:05'!
buildCode
	^'[:html :values | ', code ,']'! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:51'!
callbackValuesString
	| stream |
	stream := WriteStream on: String new.
	callbackValues keysAndValuesDo: [:k :v |
		stream nextPutAll: k asString, ' -> ', v printString.
		stream cr.].
	^stream contents! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:12'!
clearCallbackValues
	callbackValues := Dictionary new! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code
	^code! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 20:52'!
code: aString
	aString = code
		ifFalse: [
			code := aString.
			self log: aString ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/4/2010 14:25'!
cursorPositionScript
^'function setCursorPosition(pos)
{
var obj=document.getElementById(''code'');

//FOR IE
if(obj.setSelectionRange)
{
obj.focus();
obj.setSelectionRange(pos,pos);
}

// For Firefox
else if (obj.createTextRange)
{
var range = obj.createTextRange();
range.collapse(true);
range.moveEnd(''character'', pos);
range.moveStart(''character'', pos);
range.select();
}
}'! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
formTag
	^ formTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
formTag: anObject
	formTag := anObject! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:50'!
formTagList
	^self class formTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/4/2010 14:41'!
getCursorPositionScript
^'function getCursorPosition()
{
var obj=document.getElementById(''code'');
var CurPos = 0;
//FOR IE
if (document.selection)
{
obj.focus ();
var Sel = document.selection.createRange();
Sel.moveStart (''character'', -obj.value.length);
CurPos = Sel.text.length;
}
// For Firefox
else {CurPos = obj.selectionStart}
return CurPos;
}'! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/3/2010 20:38'!
historyBack
	history size > 1
		ifTrue: [
			history removeLast.
			code := history last ].
! !

!WAPlaygroundComponent methodsFor: 'initialization' stamp: 'obi 1/11/2010 22:02'!
initialize
	super initialize.
	code := ''.
	callbackValues := Dictionary new.
	saved := Dictionary new.
	history := OrderedCollection new.
	privateStyle := ''! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/11/2010 14:21'!
isSecure: aText
	| codeParts notAllowedSelectors notAllowedSubStrings |
	notAllowedSelectors := #('class' 'self' 'super' '#class').
	notAllowedSubStrings := #('compile*' 'methodDict*' 'instVar*' 'browse*' 'become*' 'halt*' '*evaluate*' 'evalString*' 'explore*' 'basic*' 'perform*' 'inspect*').
	codeParts := self split: aText.
	codeParts do: [:str | str isEmpty
			ifFalse: [
				(str includes: ${) ifTrue: [^false ].
				str first isUppercase
					ifFalse: [
						(notAllowedSelectors includes: str) ifTrue: [^false ].
						 notAllowedSubStrings do: [:each | (each match: str) ifTrue: [^false]]]
					ifTrue: [
						(Smalltalk at: str asSymbol ifAbsent: []) isNil ifFalse: [^false ] ] ] ].
	^true! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
jqueryTag
	^ jqueryTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
jqueryTag: anObject
	jqueryTag := anObject! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:21'!
loadExample
	code := self class exampleCode! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:52'!
loadJQExample
	code := self class exampleJQCode! !

!WAPlaygroundComponent methodsFor: 'logging' stamp: 'obi 1/11/2010 20:54'!
log: aString
	self class logEnabled ifTrue: [
		| fileStream |
		fileStream := FileStream fileNamed: (Date today asString, '_seaside.log')  asFileName.
		fileStream setToEnd.
		[fileStream nextPutAll: TimeStamp current asString; cr; nextPutAll: aString; cr.
		fileStream nextPutAll: '---------------------------------------------------------------------------------------------------------------------------------'; cr] ensure: 
			[fileStream close] ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/5/2010 19:49'!
onChangeScriptOn: html type: aSymbol
	^html jQuery ajax
		serializeForm;
		serializeForm: (html jQuery: #formCode);
		callback: [ :value | currentPosition := value asNumber ] value: (JSStream on: 'getCursorPosition()') ;
		script: [:s | self addTagScriptOn: s type: aSymbol]! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 22:06'!
privateStyle
	^ privateStyle! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/11/2010 22:06'!
privateStyle: anObject
	privateStyle := anObject! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/5/2010 19:10'!
renderCodeOn: html
	html div id: 'codeDiv';
		with: [
			 html textArea id: 'code'; columns: 100; rows: 20; on: #code of: self ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:31'!
renderContentOn: html
	html script: self setCursorPositionScript.
	html script: self getCursorPositionScript.
	html heading level3; with: 'Seaside playground'.
	html div id: 'output'; 
		with: [self renderOutputOrErrorOn: html].
	
	html form: [
			html table: [
				html tableRow: [
					html
						tableHeading style: 'width:820px';
							with: [
								html div id: 'lists';
									with: [self renderListsOn: html ] ].
					html tableHeading style: 'width:265px'; with: [ html anchor onClick: ((html jQuery: #valuesDiv) load html: [:r | self renderValuesOn: r]); with: 'Values' ].
					html tableHeading: 'Styles' ] ] ].
	html form id: 'formCode';
		with: [
		html table: [
			html tableRow: [
				html tableData: [ self renderCodeOn: html].
				html tableData: [self renderValuesOn: html].
				html tableData: [self renderStyleOn: html] ] .
			html tableRow: [
				html tableData: [
					html submitButton value: 'Save'; callback: [self addToHistory].
					html space.
					html submitButton value: 'Reset'; callback: [self clearCallbackValues].
					html space.
					html button value: 'Undo'; callback: [self historyBack].
					html space.
					html submitButton value: 'Clear'; callback: [code := ''. self clearCallbackValues].
					html space.
					html submitButton value: 'Example'; callback: [self loadExample ].
					html space.
					html submitButton value: 'JQ Example'; callback: [self loadJQExample ].].
				html tableData
					id: 'timeValue';
					with: [self renderTimeValueOn: html] ]  ] ].
	    ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/5/2010 19:11'!
renderListsOn: html
	html select
		onChange: (self onChangeScriptOn: html type: #simpleTag);
		list: self tagList;
		beOptional;
		optionalLabel: '- Simple tags - ';
		callback: [:value | simpleTag := value. ].
	html space.
	html select
		onChange: (self onChangeScriptOn: html type: #formTag);
		list: self formTagList;
		beOptional;
		optionalLabel: '- Form tags - ';
		callback: [:value | formTag := value. ].
	html space.
	html select
		onChange: (self onChangeScriptOn: html type: #tableTag);
		list: self tableTagList;
		beOptional;
		optionalLabel: '- Table tags - ';
		callback: [:value | tableTag := value. ].
	html space.
	html select
		onChange: (self onChangeScriptOn: html type: #jqueryTag);
		list: self class jqueryTagTemplates keys asSortedCollection;
		beOptional;
		optionalLabel: '- JQuery tags - ';
		callback: [:value | jqueryTag := value. ].! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:00'!
renderOutputOn: html
	| ms aBlock |
	[aBlock := Compiler evaluate: self buildCode.
	ms := Time millisecondClockValue.
	aBlock value: html value: callbackValues.
	msValue := (Time millisecondClockValue - ms) asString, ' ms'.  ] on: Halt, Error, Warning, ParserNotification do: [:ex | html div class: 'error'; with: ex ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 21:51'!
renderOutputOrErrorOn: html
	| ms |
	msValue := 'NA'.
	(self isSecure: code) 
				ifTrue: [ms := Time millisecondClockValue.
						self renderOutputOn: html.
						msValue := (Time millisecondClockValue - ms) asString, ' ms'. ]
				ifFalse: [html div class: 'error'; with: 'Due security restrictions you are not allowed to execute the entered code!!' ]
				 ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:07'!
renderStyleOn: html
	html div id: 'styleDiv';
		with: [ html textArea columns: 40; rows: 20; on: #privateStyle of: self]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:27'!
renderTimeValueOn: html
	html span style: 'color:#eee'; with: 'Rendering time: ', msValue
	    ! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:24'!
renderValuesOn: html
	html div id: 'valuesDiv';
		with: [ html textArea columns: 30; rows: 20; value: self callbackValuesString]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/4/2010 14:33'!
setCursorPositionScript
^'function setCursorPosition(pos)
{
var obj=document.getElementById(''code'');

//FOR IE
if(obj.setSelectionRange)
{
obj.focus();
obj.setSelectionRange(pos,pos);
}

// For Firefox
else if (obj.createTextRange)
{
var range = obj.createTextRange();
range.collapse(true);
range.moveEnd(''character'', pos);
range.moveStart(''character'', pos);
range.select();
}
}'! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
simpleTag
	^ simpleTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
simpleTag: anObject
	^ simpleTag := anObject! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/11/2010 21:46'!
split: aString 
	| lines in out c |
	lines := OrderedCollection new.
	in := aString readStream.
	out := String new writeStream.
	[ in atEnd ] whileFalse: 
		[ ((c := in next) isSeparator or: [c == $. or: [c == $; or: [c == $' or: [c == $( or: [c == $[ or: [c == $) or: [c == $] or: [c == $}] ]]]]]]])
			ifTrue: 
				[out position = 0 ifFalse: [ lines add: out contents ].
				out reset ]
			ifFalse: [ out nextPut: c ] ].
	out position = 0 ifFalse: [ lines add: out contents ].
	^ lines! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/11/2010 22:28'!
style
	^'html { overflow-y: scroll; }
body { margin: 0; padding: 0; background: #434242 url(background.png) repeat-x; font-family: Helvetica,Arial,Verdana,sans-serif; font-size: 80%; line-height: 1.5; color: #222; }
a { text-decoration: none; color: #ff7200; outline: none; cursor: pointer; }
h1, h2, h3, h4, h5, h6 { border: 0; margin: 0; font-weight: normal; letter-spacing: 1px; }
	
h3, th  {
color:#FF7200;
font-size:20px;
margin-bottom:6px;}
th {text-align:left}
.error {color:red;font-size:14px;font-family:verdana}
 #output {background:#fff;height:400px;overflow:auto;border:1px solid #ccc;padding:4px;margin:4px}
.box {width:50px;height:50px;background:blue;border:2px solid black;}
', privateStyle! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
tableTag
	^ tableTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
tableTag: anObject
	tableTag := anObject! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 21:07'!
tableTagList
	^self class tableTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:42'!
tagList
	^self class simpleTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:58'!
templateAt: aSymbol
	^(self class perform: (aSymbol, 'Templates') asSymbol) at: (self perform: aSymbol) ifAbsent: []! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:39'!
theme
	^JQBaseTheme default! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/9/2010 18:53'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	self theme updateRoot: anHtmlRoot! !
WAPlaygroundComponent initialize!
